app/app/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static

from app import settings
from main import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls', namespace="main")),
    path('catalog/', include('goods.urls', namespace="catalog")),
    path('user/', include('users.urls', namespace="user")),
    path('cart/', include('carts.urls', namespace="cart")),
]

if settings.DEBUG:
    urlpatterns += [
        path("__debug__/", include("debug_toolbar.urls")),
    ]
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app/users/urls.py
from django.contrib import admin
from django.urls import path
from users import views

app_name = 'users'

urlpatterns = [
    path('login/', views.login, name='login'),
    path('registration/', views.registration, name='registration'),
    path('profile/', views.profile, name='profile'),
    path('users-cart/', views.users_cart, name='users_cart'),
    path('logout/', views.logout, name='logout'),
]

app/users/models.py
from django.contrib.auth.models import AbstractUser
from django.db import models

class User(AbstractUser):
    image = models.ImageField(upload_to='users_images', blank=True, null=True, verbose_name="Avatar")

    class Meta:
        db_table = 'user'
        verbose_name = 'User'
        verbose_name_plural = 'Users'

    def __str__(self):
        return self.username

app/users/forms.py
from django import forms
from django.contrib.auth.forms import AuthenticationForm, UserCreationForm, UserChangeForm
from users.models import User


class UserLoginForm(AuthenticationForm):

    class Meta:
        model = User
        fields = ('username', 'password')

    username = forms.CharField()
    password = forms.CharField()


class UserRegistrationForm(UserCreationForm):
    class Meta:
        model = User
        fields = (
            'first_name',
            'last_name',
            'username',
            'email',
            'password1',
            'password2'
        )

    first_name = forms.CharField()
    last_name = forms.CharField()
    username = forms.CharField()
    email = forms.CharField()
    password1 = forms.CharField()
    password2 = forms.CharField()


class ProfileForm(UserChangeForm):
    class Meta:
        model = User
        fields = (
            'image',
            'first_name',
            'last_name',
            'username',
            'email',
        )

    image = forms.ImageField(required=False)
    first_name = forms.CharField()
    last_name = forms.CharField()
    username = forms.CharField()
    email = forms.CharField()

app/users/views.py
from django.contrib import auth, messages
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.shortcuts import render, redirect
from django.urls import reverse

from carts.models import Cart
from users.forms import UserLoginForm, UserRegistrationForm, ProfileForm


def login(request):
    if request.method == 'POST':
        form = UserLoginForm(data=request.POST)
        if form.is_valid():
            username = request.POST['username']
            password = request.POST['password']
            user = auth.authenticate(username=username, password=password)

            session_key = request.session.session_key

            if user:
                auth.login(request, user)
                messages.success(request, f'{username}, you are logged in')

                if session_key:
                    Cart.objects.filter(session_key=session_key).update(user=user)

                redirect_page = request.POST.get('next', None)
                if redirect_page and redirect_page!=reverse('users:logout'):
                    return HttpResponseRedirect(request.POST.get('next'))
                return HttpResponseRedirect(reverse('main:index'))
    elif request.method == 'GET':
        form = UserLoginForm()

    context = {
        'title': 'Home - Autorization',
        'form': form
    }
    return render(request, 'users/login.html', context)


def registration(request):
    if request.method == 'POST':
        form = UserRegistrationForm(data=request.POST)
        if form.is_valid():
            form.save()

            session_key = request.session.session_key

            user = form.instance
            auth.login(request, user)

            if session_key:
                Cart.objects.filter(session_key=session_key).update(user=user)()
            messages.success(request, f"{user.username}, you have successfully registered and logged into your account")
            return HttpResponseRedirect(reverse('main:index'))
    elif request.method == 'GET':
        form = UserRegistrationForm()

    context = {
        'title': 'Home - Registration',
        'form': form
    }
    return render(request, 'users/registration.html', context)

@login_required
def profile(request):
    if request.method == 'POST':
        form = ProfileForm(data=request.POST, instance=request.user, files=request.FILES)
        if form.is_valid():
            form.save()
            messages.success(request, "Profile updated successfully")
            return HttpResponseRedirect(reverse('user:profile'))

    elif request.method == 'GET':
        form = ProfileForm(instance=request.user)

    context = {
        'title': 'Home - Cabinet',
        'form': form
    }
    return render(request, 'users/profile.html', context)

def users_cart(request):
    return render(request, 'users/users-cart.html')


@login_required
def logout(request):
    messages.success(request, f"{request.user.username}, You logged out from account")
    auth.logout(request)
    return redirect(reverse('main:index'))

app/users/templates/users/login.html
{% extends 'base.html' %}
{% load static %}

{% block modal_cart %}
    {% include "includes/cart_button.html" %}
{% endblock modal_cart %}

{% block content %}
    <div class="row">
        <div class="container mt-5">
            <div class="row justify-content-center">
                <div class="col-md-6 bg-white p-4 mb-4 mx-3 rounded custom-shadow">
                    <h2 class="text-center mb-4">Авторизация</h2>
                    <form action="{% url 'user:login' %}" method="post">
                        {% csrf_token %}

                        {% if request.GET.next %}
                            <input type="hidden" name="next" value={{ request.GET.next }}>
                        {% endif %}

                        <div class="mb-3">
                            <label for="id_username" class="form-label">{{ form.username.label }}</label>
                            <input type="text" class="form-control"
                                   value="{% if form.username.value %}{{ form.username.value }}{% endif %}"
                                   name="username" id="id_username"
                                   placeholder="Enter your username"
                                    required>
                        </div>
                        <div class="mb-3">
                            <label for="id_password" class="form-label">{{ form.password.label }}</label>
                            <input type="password" class="form-control" name="password" id="id_password"
                                   placeholder="Enter your password" required>
                        </div>

                        <button type="submit" class="btn btn-dark btn-block">Войти</button>
                    </form>
                    <div class="mt-3">
                        <a href="#">Забыли пароль?</a> | <a href="{% url 'users:registration' %}">Создать аккаунт</a>
                    </div>
                    <hr>
                    <div class="text-center">
                        <p>Или авторизуйтесь через:</p>
                        <a href="#" class="btn btn-dark">
                            <img class="mx-1" src="{% static "deps/icons/google.svg" %}" alt="Catalog Icon" width="16" height="16">
                            Google
                        </a>
                        <a href="#" class="btn btn-dark">
                            <img class="mx-1" src="{% static "deps/icons/facebook.svg" %}" alt="Catalog Icon" width="16" height="16">
                            Facebook
                        </a>
                        <a href="#" class="btn btn-dark">
                            <img class="mx-1" src="{% static "deps/icons/github.svg" %}" alt="Catalog Icon" width="16" height="16">
                            GitHub
                        </a>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

app/users/templates/users/profile.html
{% extends 'base.html' %}
{% load static %}
{% load carts_tags %}

{% block content %}
    <div class="row">
        <div class="container mt-5">
            <div class="row">
                <!-- Профиль с данными пользователя -->
                <div class="col-md-5">
                    <div class=" bg-white p-4 mb-4 mx-2 rounded custom-shadow">
                        <h3 class="text-center mb-4">Профиль пользователя</h3>
                        <form action="{% url "users:profile" %}" method="post" enctype="multipart/form-data">
                            {% csrf_token %}
                            <div class="row">
                                <div class="col-md-12 mb-3 text-center">
                                    {% if user.image %}
                                        <img src="{{ user.image.url }}"
                                            alt="Аватар пользователя" class="img-fluid rounded-circle"
                                            style="max-width: 150px;">
                                    {% else %}
                                        <img src="{% static 'deps/images/baseavatar.jpg' %}"
                                            alt="Аватар пользователя" class="img-fluid rounded-circle"
                                            style="max-width: 150px;">
                                    {% endif %}
                                    <input type="file" class="form-control mt-3" id="id_image"
                                        name="image"
                                        accept="image/*">
                                    {% if form.first_name.errors %}
                                        <div class="alert alert-danger alert-dismissible fade show">{{ form.first_name.errors }}</div>
                                    {% endif %}
                                </div>
                                <div class="col-md-12 mb-3">
                                    <label for="id_first_name" class="form-label">Имя*</label>
                                    <input type="text" class="form-control" id="id_first_name"
                                        name="first_name"
                                        placeholder="Введите ваше имя"
                                        value="{{ form.first_name.value }}" required>
                                    {% if form.first_name.errors %}
                                        <div class="alert alert-danger alert-dismissible fade show">{{ form.first_name.errors }}</div>
                                    {% endif %}
                                </div>
                                <div class="col-md-12 mb-3">
                                    <label for="last_name" class="form-label">Фамилия*</label>
                                    <input type="text" class="form-control" id="last_name"
                                        name="last_name"
                                        placeholder="Введите вашу фамилию"
                                        value="{{ form.last_name.value }}" required>
                                    {% if form.last_name.errors %}
                                        <div class="alert alert-danger alert-dismissible fade show">{{ form.last_name.errors }}</div>
                                    {% endif %}
                                </div>
                                <div class="col-md-12 mb-3">
                                    <label for="id_username" class="form-label">Имя пользователя*</label>
                                    <input type="text" class="form-control" id="id_username"
                                        name="username"
                                        placeholder="Введите ваше имя пользователя"
                                        value="{{ form.username.value }}" required>
                                    {% if form.username.errors %}
                                        <div class="alert alert-danger alert-dismissible fade show">{{ form.username.errors }}</div>
                                    {% endif %}
                                </div>
                                <div class="col-md-12 mb-3">
                                    <label for="id_email" class="form-label">Email*</label>
                                    <input type="email" class="form-control" id="id_email"
                                        name="email"
                                        placeholder="Введите ваш email *youremail@example.com"
                                        value="{{ form.email.value }}"
                                        required>
                                    {% if form.email.errors %}
                                        <div class="alert alert-danger alert-dismissible fade show">{{ form.email.errors }}</div>
                                    {% endif %}
                                </div>
                            </div>
                            <button type="submit" class="btn btn-dark">Сохранить</button>
                        </form>
                    </div>
                </div>
                <!-- Корзина -->
                {% user_carts request as carts %}
                <div class="col-md-7">
                    <div class=" bg-white p-4 mb-4 mx-2 rounded custom-shadow">
                        <h3 class="text-center mb-4">Корзина</h3>
                        <div class="container" id="cart-items-container">
                            <!-- Разметка корзины -->
                            {% include "carts/includes/included_cart.html" %}
                            <!-- Закончилась разметка корзины -->
                        </div>
                        {% if carts %}
                            <a class="btn btn-dark" href="orders/create_order.html">
                            Оформить заказ
                            </a>
                        {% endif %}
                    </div>
                </div>
                <!-- Оформленные заказы -->
                <div class="col-md-12">
                    <div class=" bg-white p-4 mb-4 mx-2 rounded custom-shadow">
                        <h3 class="text-center mb-4">Мои заказы</h3>
                        <!-- Разметка заказов -->
                        <div class="container">
                            <div class="accordion" id="accordionExample">
                                <div class="accordion-item">
                                    <h2 class="accordion-header" id="heading1">
                                        <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#collapse1" aria-expanded="false" aria-controls="collapse1">
                                            Заказ № 256 - 09 сентября 2023 9:04 | Статус:<strong class="mx-2"> В обработке</strong>
                                        </button>
                                    </h2>
                                    <div id="collapse1" class="accordion-collapse collapse show" aria-labelledby="heading1" data-bs-parent="#accordionExample">
                                        <div class="accordion-body">
                                            <table class="table table-dark table-hover">
                                                <thead>
                                                    <tr>
                                                        <th>Товар</th>
                                                        <th>Количество</th>
                                                        <th>Цена</th>
                                                        <th>Общая стоимость</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <tr>
                                                        <td><a class="text-white" href="#">Комплект стол и три стула</a></td>
                                                        <td>1</td>
                                                        <td>255.00 $</td>
                                                        <td>255.00 $</td>

                                                    </tr>
                                                </tbody>
                                            </table>
                                            <div class="d-flex justify-content-between">
                                                <p><strong>Итого:</strong></p>
                                                <p><strong>255.00 $</strong></p>

                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="accordion-item">
                                    <h2 class="accordion-header" id="heading2">
                                        <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapse2" aria-expanded="false" aria-controls="collapse2">
                                            Заказ № 248 - 01 августа 2023 11:28 | Статус: <strong>Получен</strong>
                                        </button>
                                    </h2>
                                    <div id="collapse2" class="accordion-collapse collapse" aria-labelledby="heading2" data-bs-parent="#accordionExample">
                                        <div class="accordion-body">
                                            <table class="table table-dark table-hover">
                                                <thead>
                                                    <tr>
                                                        <th>Товар</th>
                                                        <th>Количество</th>
                                                        <th>Цена</th>
                                                        <th>Общая стоимость</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <tr>
                                                        <td><a class="text-white" href="#">Стул офисный</a></td>
                                                        <td>2</td>
                                                        <td>30.00 $</td>
                                                        <td>60.00 $</td>

                                                    </tr>
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- Закончилась разметка заказов -->
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

app/users/templates/users/registration.html
{% extends 'base.html' %}
{% load static %}

{% block modal_cart %}
    {% include "includes/cart_button.html" %}
{% endblock modal_cart %}

{% block content %}
    <div class="row">
        <div class="container mt-5">
            <div class="row justify-content-center">
                <div class="col-md-9 bg-white p-4 mb-5 mx-2 rounded custom-shadow">
                    <h2 class="text-center mb-4">Регистрация</h2>
                    <form action="{% url "user:registration" %}" method="post">
                        {% csrf_token %}
                        <div class="row">
                            <div class="col-md-6 mb-3">
                                <label for="id_first_name" class="form-label">Имя*</label>
                                <input type="text" class="form-control" id="id_first_name"
                                    value="{% if form.first_name.value %}{{ form.first_name.value }}{% endif %}"
                                    name="first_name"
                                    placeholder="Введите ваше имя" required>
                                {% if form.first_name.errors %}
                                    <div class="alert alert-danger alert-dismissible fade show">{{ form.first_name.errors }}</div>
                                {% endif %}
                            </div>
                            <div class="col-md-6 mb-3">
                                <label for="id_last_name" class="form-label">Фамилия*</label>
                                <input type="text" class="form-control" id="id_last_name"
                                    value="{% if form.last_name.value %}{{ form.last_name.value }}{% endif %}"
                                    name="last_name"
                                    placeholder="Введите вашу фамилию" required>
                                {% if form.last_name.errors %}
                                    <div class="alert alert-danger alert-dismissible fade show">{{ form.last_name.errors }}</div>
                                {% endif %}
                            </div>
                            <div class="col-md-6 mb-3">
                                <label for="id_username" class="form-label">Имя пользователя*</label>
                                <input type="text" class="form-control" id="id_username"
                                    value="{% if form.username.value %}{{ form.username.value }}{% endif %}"
                                    name="username"
                                    placeholder="Введите ваше имя пользователя" required>
                                {% if form.username.errors %}
                                    <div class="alert alert-danger alert-dismissible fade show">{{ form.username.errors }}</div>
                                {% endif %}
                            </div>
                            <div class="col-md-6 mb-3">
                                <label for="id_email" class="form-label">Email*</label>
                                <input type="email" class="form-control" id="id_email"
                                    value="{% if form.email.value %}{{ form.email.value }}{% endif %}"
                                    name="email"
                                    placeholder="Введите ваш email" required>
                                {% if form.email.errors %}
                                    <div class="alert alert-danger alert-dismissible fade show">{{ form.email.errors }}</div>
                                {% endif %}
                            </div>
                            <div class="col-md-6 mb-3">
                                <label for="id_password1" class="form-label">Пароль*</label>
                                <input type="password" class="form-control" id="id_password1"
                                    value="{% if form.password1.value %}{{ form.password1.value }}{% endif %}"
                                    name="password1"
                                    placeholder="Введите пароль" required>
                                {% if form.password1.errors %}
                                    <div class="alert alert-danger alert-dismissible fade show">{{ form.password1.errors }}</div>
                                {% endif %}
                            </div>
                            <div class="col-md-6 mb-3">
                                <label for="id_password2" class="form-label">Подтверждение пароля*</label>
                                <input type="password" class="form-control" id="id_password2"
                                    value="{% if form.password2.value %}{{ form.password2.value }}{% endif %}"
                                    name="password2"
                                    placeholder="Подтвердите пароль" required>
                                {% if form.password2.errors %}
                                    <div class="alert alert-danger alert-dismissible fade show">{{ form.password2.errors }}</div>
                                {% endif %}
                            </div>
                        </div>
                        <button type="submit"
                            class="btn btn-dark btn-block">Зарегистрироваться</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

app/users/templates/users/users-cart.html
{% extends "base.html" %}
{% load static %}
{% load carts_tags %}


{% block content %}
    {% user_carts request as carts %}
    <div class="container">
    <div class="row mt-1">
        <div class="col-lg-2">
            <!-- Пустой блок на усмотрение -->
        </div>
        <div class="col-lg-10">
            <!-- Контент на странице -->
            <div class="row">
                <div class="container mt-5">
                    <div class="row justify-content-center">
                        <div class=" bg-white p-4 mb-4 mx-2 rounded custom-shadow">
                            <h3 class="text-center mb-4">Корзина</h3>
                            <div class="container" id="cart-items-container">
                                <!-- Разметка корзины -->
                                {% include "carts/includes/included_cart.html" %}
                                <!-- Закончилась разметка корзины -->
                            </div>
                            {% if carts %}
                                <a class="btn btn-dark" href="orders/create_order.html">
                                Оформить заказ
                                </a>
                            {% endif %}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </div>
{% endblock content %}